# -*- coding: utf-8 -*-
import time
import numpy as np
def _equal(pt1,pt2,tol):
    dis = np.linalg.norm(pt1 - pt2)
    if dis < tol:
        return True
    else:
        return False
def extractCommonSequence(lcsMat,isEqual):
    n,m = isEqual.shape
    subSeqAIndex=[]
    subSeqBIndex=[]
    i = n-1
    j = m-1
    while i != 0 and j != 0:
        if isEqual[i][j] == 1:
            subSeqAIndex.insert(0, i)
            subSeqBIndex.insert(0, j)
            i = i-1
            j = j-1
        elif lcsMat[i+1][j] >= lcsMat[i][j+1]:
            j = j - 1
        else:
            i = i - 1
    return [subSeqAIndex, subSeqBIndex]
def LongestCommonSubsequence(seqA,seqB,tol):
    n = seqA.shape[0]
    m = seqB.shape[0]
    lcsMat = np.zeros((n+1, m+1), dtype=np.int)
    isEqual = np.zeros((n, m), dtype=np.int)
    for i in range(n):
        for j in range(m):
            if _equal(seqA[i],seqB[j],tol):
                lcsMat[i + 1][j + 1] = lcsMat[i][j] + 1
                isEqual[i][j] = 1
            else:
                lcsMat[i + 1][j + 1] = max(lcsMat[i + 1][j],lcsMat[i][j + 1])
    sequence = extractCommonSequence(lcsMat,isEqual)
    similarity = 1-lcsMat[n][m]*1.0/min(n,m)
    return lcsMat[n][m],similarity,sequence