# -*- coding: utf-8 -*-
import numpy as np
from scipy.spatial.distance import cdist
import time
def extractPath(costMatrix,i,j):
    path = []
    while i != 0 and j != 0:
        path.insert(0, (i, j))
        idxArr = [(i-1,j),(i-1,j-1),(i,j-1)]
        minArg = np.argmin(np.array([
            costMatrix[i - 1][j],
            costMatrix[i - 1][j - 1],
            costMatrix[i][j - 1]]))
        minIndex = idxArr[minArg]
        i = minIndex[0]
        j = minIndex[1]
    while i != 0:
        path.insert(0, (i, 0))
        i = i-1
    while j != 0:
        path.insert(0, (0, j))
        j = j - 1
    path.insert(0, (0, 0))
    return path
def DynamicTimeWarping(ptSetA, ptSetB):
    n = ptSetA.shape[0]
    m = ptSetB.shape[0]
    disMat = cdist(ptSetA, ptSetB, metric='euclidean')
    costMatrix = np.full((n, m), -1.0)
    for i in range(n):
        for j in range(m):
            if i == 0 and j == 0:
                costMatrix[0][0] = disMat[0][0]
            if i == 0 and j > 0:
                costMatrix[0][j] = costMatrix[0][j-1]+disMat[0][j]
            if i > 0 and j == 0:
                costMatrix[i][0] = costMatrix[i-1][0]+disMat[i][0]
            if i > 0 and j > 0:
                costMatrix[i][j] = min(costMatrix[i-1][j],
                                           costMatrix[i-1][j-1],
                                           costMatrix[i][j-1]) + disMat[i][j]
    path = extractPath(costMatrix, n - 1, m - 1)
    return costMatrix[n-1][m-1],path